<template>
 <v-page>
   <div v-show="confirmed">
     <font-awesome-icon icon="check-circle" class="icon-success"/>
     <br/>
     <div class="text">Email confirmed</div>
   </div>
   <div v-show="!confirmed && !error">
     Confirming email...
     <br/>
     <br/>
     <v-button in-progress></v-button>
   </div>
   <v-retry-button v-show="error === ConfirmingEmailError.SERVER_ERROR" @click="confirmEmail"/>
   <FormErrorMessage v-show="error === ConfirmingEmailError.CANNOT_CONFIRM_EMAIL">{{ error }}</FormErrorMessage>
  </v-page>
</template>

<script>
  import { FontAwesomeIcon } from '@fortawesome/vue-fontawesome'
  import { library } from '@fortawesome/fontawesome-svg-core'
  import { faCheckCircle } from '@fortawesome/free-solid-svg-icons'
  import { createNamespacedHelpers } from 'vuex'

  import { VPage } from 'zeus-common'
  import VButton from 'zeus-common/src/component/button/VButton'
  import VRetryButton from 'zeus-common/src/component/button/VRetryButton'
  import FormErrorMessage from 'zeus-common/src/component/input/FormErrorMessage'
  import { ConfirmingEmailError } from '@/pages/confirming-email/service'

  library.add(faCheckCircle)

  const { mapState } = createNamespacedHelpers('confirmingEmail')

  export default {
    name: 'ConfirmingEmailPage',
    components: { FormErrorMessage, VRetryButton, VButton, FontAwesomeIcon, VPage },
    props: {
      token: String
    },
    data: () => ({
      ConfirmingEmailError: ConfirmingEmailError
    }),
    computed: {
      ...mapState([ 'inProgress', 'error', 'confirmed' ])
    },
    mounted() {
      this.confirmEmail()
    },
    methods: {
      confirmEmail() {
        if (this.error) {
          this.$store.commit('confirmingEmail/resetError')
        }
        this.$store.dispatch('confirmingEmail/confirmEmail', this.token)
      }
    }
  }
</script>

<style scoped lang="scss">
  @import "~zeus-common/src/component/color";

  .icon-success {
    color: $color-success;
    font-size: 2.5em;
    margin-top: 0.5em;
    margin-bottom: 0.5em;
  }

  .text {
    margin-bottom: 1em;
  }
</style>